package org.xbib.interlibrary.catalog.elasticsearch;

import java.io.IOException;
import org.elasticsearch.common.settings.Settings;
import org.xbib.elx.api.AdminClient;
import org.xbib.elx.common.DefaultIndexDefinition;

public class ElasticsearchIndexDefinition extends DefaultIndexDefinition {

    public ElasticsearchIndexDefinition(String index, String type) {
        super(index, type);
    }

    public ElasticsearchIndexDefinition(AdminClient adminClient,
                                        String index,
                                        String type,
                                        Settings settings,
                                        ClassLoader classLoader) throws IOException {
        super(adminClient, index, type, settings, classLoader);
        // never allow empty indices to be shifted
        setShiftNotEmpty(true);
    }

    @Override
    public String toString() {
        return "[index=" + getIndex() + ",fullindexname=" + getFullIndexName() + "]";
    }
}
