package org.xbib.interlibrary.catalog.elasticsearch.doaj;

import java.io.IOException;
import org.xbib.interlibrary.catalog.elasticsearch.oai.ElasticsearchToolOAI;
import org.xbib.oai.xml.MetadataHandler;
import org.xbib.settings.Settings;

/**
 * Harvest documents from DOAJ OAI and index them into Elasticsearch.
 */
public class DOAJ extends ElasticsearchToolOAI {

    public DOAJ() {
    }

    @Override
    public DOAJWorkerPool newPool(Settings settings) throws IOException {
        return new DOAJWorkerPool(settings);
    }

    public class DOAJWorkerPool extends ElasticsearchOAIWorkerPool {

        public DOAJWorkerPool(Settings settings) throws IOException {
            super(settings);
        }

        @Override
        public DOAJWorker newWorker(String name, int count) {
            return new DOAJWorker(settings, this);
        }
    }

    public class DOAJWorker extends ElasticsearchOAIWorker {

        public DOAJWorker(Settings settings, DOAJWorkerPool pool) {
            super(settings, pool);
        }

        @Override
        protected MetadataHandler getMetadataHandler() {
            return new OAISimpleMetadataHandler(this);
        }

        @Override
        protected String convert(String id, String content) throws IOException {
            return content;
        }
    }
}
