package org.xbib.interlibrary.catalog.elasticsearch.lvi;

import java.util.Collection;

import org.xbib.interlibrary.api.product.Product;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics.Countable;
import org.xbib.marc.MarcField;

public interface Holdings extends Countable, Comparable<Holdings> {

    String getKey();

    boolean isDeleted();

    boolean isMerged();

    boolean isGreen();

    String getIdentifier();

    String getISIL();

    String getDomain();

    Collection<Service> getServices();

    Collection<MarcField> asMarc();

    Collection<Product> getProducts();

    void merge(Holdings holdings);

    void addYear(int year);

    void addYears(String firstyear, String lastyear);

    Collection<Integer> getYears();

    interface Builder {

        Builder setDeleted(boolean deleted);

        Builder setMerged(boolean merged);

        Holdings build();
    }
}
