package org.xbib.interlibrary.catalog.elasticsearch.lvi;

import java.time.LocalDate;
import java.util.Collection;
import java.util.List;

import org.xbib.interlibrary.api.library.Material;
import org.xbib.interlibrary.api.product.Product;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics.Countable;
import org.xbib.marc.MarcRecord;

public interface Record extends Countable, Comparable<Record> {

    LocalDate getCreationDate();

    LocalDate getModificationDate();

    String getKey();

    boolean isDeleted();

    List<Material> getMaterials();

    boolean isSerialMirror();

    boolean isGreen();

    boolean isOpenAccess();

    String getIdentifier();

    String getExternalIdentifier();

    String getBaseUrl();

    MarcRecord getMarcRecord();

    Holdings addHoldings(Holdings.Builder item);

    Collection<Holdings> getHoldings();

    void addAlias(String alias);

    Collection<String> getAlias();

    Collection<Service.LabeledUrl> getGlobalServices();

    Integer getPublicationDate();

    String getChronology();

    Collection<Product> getProducts();

    interface Builder {

        Record build();
    }
}
