package org.xbib.interlibrary.catalog.elasticsearch.lvi;

import java.util.ArrayList;
import java.util.Collection;
import org.xbib.interlibrary.api.library.Material;
import org.xbib.interlibrary.api.library.Mode;

public interface Service {

    void setISIL(String isil);

    String getISIL();

    void setMode(Mode mode);

    Mode getMode();

    void setMaterial(Material material);

    Material getMaterial();

    void setCollection(String collection);

    String getCollection();

    void setCallnumber(String callnumber);

    String getCallnumber();

    void setCallnumber2(String callnumber2);

    void setTextualHoldings(String textualHoldings);

    String getTextualHoldings();

    void setMovingWall(String movingWall);

    String getMovingWall();

    void setYears(Collection<Integer> years);

    Collection<Integer> getYears();

    String getCallnumber2();

    void setDescription(String description);

    String getDescription();

    void setDelta(int delta);

    int getDelta();

    void addUrl(LabeledUrl url);

    LabeledUrlList getUrls();

    void setFirstStatusCode(String firstStatusCode);

    String getFirstStatusCode();

    void setSecondStatusCode(String secondStatusCode);

    String getSecondStatusCode();

    void setThirdStatusCode(String thirdStatusCode);

    String getThirdStatusCode();

    void setItemProcessCode(String itemProcessCode);

    String getItemProcessCode();

    void computeYears();

    class LabeledUrl {

        private String url;

        private String label;

        public LabeledUrl() {
        }

        public void setUrl(String url) {
            if (url != null) {
                this.url = url.replaceAll("http://www.bibliothek.uni-regensburg.de/ezeit/", "https://ezb.ur.de/");
            }
        }

        public String getUrl() {
            return url;
        }

        public void setLabel(String label) {
            this.label = label;
        }

        public String getLabel() {
            return label;
        }

        @Override
        public int hashCode() {
            return url != null ? url.hashCode() : 0;
        }

        @Override
        public boolean equals(Object obj) {
            return obj instanceof LabeledUrl && url != null && url.equals(((LabeledUrl) obj).getUrl());
        }

        public String toString() {
            return url + "[" + label + "]";
        }
    }

    @SuppressWarnings("serial")
    class LabeledUrlList extends ArrayList<LabeledUrl> {

        public LabeledUrlList() {
        }

        @Override
        public boolean add(LabeledUrl labeledUrl) {
            if (!contains(labeledUrl)) {
                return super.add(labeledUrl);
            }
            return false;
        }

        @Override
        public int hashCode() {
            return isEmpty() ? 0 : get(0).hashCode();
        }

        @Override
        public boolean equals(Object obj) {
            return obj instanceof LabeledUrlList &&
                    ((isEmpty() && ((LabeledUrlList) obj).isEmpty()) ||
                    (!isEmpty() && !((LabeledUrlList) obj).isEmpty() && get(0).equals(((LabeledUrlList) obj).get(0))));
        }

        public String toString() {
            return isEmpty() ? "" : get(0).toString();
        }
    }
}
