package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Record;
import org.xbib.settings.Settings;

class RecordGreenCountStatistics extends CountStatistics<Record> {

    RecordGreenCountStatistics(Settings settings, String prefix) {
        super(settings, prefix, "records.greencount");
    }

    @Override
    public void count(Record record) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (record == null) {
            return;
        }
        String category = record.getCategory();
        if (category == null) {
            return;
        }
        if (record.isGreen()) {
            Integer i = integerMapBuilder.getOrDefault(category, 0);
            integerMapBuilder.put(category, i + 1);
        }
    }
}
