package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;

import org.xbib.interlibrary.api.library.Material;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Record;
import org.xbib.settings.Settings;

class RecordMaterialCountStatistics extends CountStatistics<Record> {

    RecordMaterialCountStatistics(Settings settings, String prefix) {
        super(settings, prefix, "records.materialcount");
    }

    @Override
    public void count(Record record) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (record == null) {
            return;
        }
        String category = record.getCategory();
        if (category == null) {
            return;
        }
        for (Material material : record.getMaterials()) {
            String key = category + "_" + material.name();
            Integer i = integerMapBuilder.getOrDefault(key, 0);
            integerMapBuilder.put(key, i + 1);
        }
    }
}
