package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Holdings;
import org.xbib.settings.Settings;

class ResourceCountStatistics extends CountStatistics<Holdings> {

    ResourceCountStatistics(Settings settings, String prefix) {
        super(settings, prefix, "resources.count");
    }

    @Override
    public void count(Holdings holdings) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (holdings == null) {
            return;
        }
        String category = holdings.getCategory();
        if (category == null) {
            return;
        }
        Integer i = integerMapBuilder.getOrDefault(category, 0);
        integerMapBuilder.put(category, i + holdings.getServices().size());
    }
}
