package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Holdings;
import org.xbib.settings.Settings;

class ResourceDeletedCountStatistics extends CountStatistics<Holdings> {

    ResourceDeletedCountStatistics(Settings settings, String prefix) {
        super(settings, prefix, "resources.deletedcount");
    }

    @Override
    public void count(Holdings holdings) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (holdings == null) {
            return;
        }
        String category = holdings.getCategory();
        if (category == null) {
            return;
        }
        if (holdings.isDeleted()) {
            Integer i = integerMapBuilder.getOrDefault(category, 0);
            integerMapBuilder.put(category, i + 1);
        }
    }
}
