package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Holdings;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Service;
import org.xbib.settings.Settings;

class ResourceItemProcessStatistics extends CodeMapStatistics<Holdings> {

    ResourceItemProcessStatistics(Settings settings, String prefix) {
        super(settings, prefix, "resources.itemprocess");
    }

    @Override
    public void count(Holdings holdings) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (holdings == null) {
            return;
        }
        String category = holdings.getCategory();
        if (category == null) {
            return;
        }
        CodeMap codeMap = codeMapBuilder.getOrDefault(category, new CodeMap());
        for (Service service : holdings.getServices()) {
            String itemProcessCode = service.getItemProcessCode();
            if (itemProcessCode != null) {
                codeMap.add(itemProcessCode);
            }
        }
        codeMapBuilder.put(category, codeMap);
    }
}
