package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Holdings;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Service;
import org.xbib.settings.Settings;

class ResourceMaterialCountStatistics extends CountStatistics<Holdings> {

    ResourceMaterialCountStatistics(Settings settings, String prefix) {
        super(settings, prefix, "resources.materialcount");
    }

    @Override
    public void count(Holdings holdings) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (holdings == null) {
            return;
        }
        String category = holdings.getCategory();
        if (category != null) {
            for (Service service : holdings.getServices()) {
                String key = category + "_" + service.getMaterial().name();
                Integer i = integerMapBuilder.getOrDefault(key, 0);
                integerMapBuilder.put(key, i + 1);
            }
        }
    }
}
