package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.util.ConcurrentModificationException;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Holdings;
import org.xbib.interlibrary.catalog.elasticsearch.lvi.Service;
import org.xbib.settings.Settings;

class ResourceStatusCodeStatistics extends CodeMapStatistics<Holdings> {

    ResourceStatusCodeStatistics(Settings settings, String prefix) {
        super(settings, prefix, "resources.statuscode");
    }

    @Override
    public void count(Holdings holdings) {
        if (!enabled) {
            return;
        }
        if (closed) {
            throw new ConcurrentModificationException();
        }
        if (holdings == null) {
            return;
        }
        String category = holdings.getCategory();
        if (category == null) {
            return;
        }
        CodeMap codeMap = codeMapBuilder.getOrDefault(category, new CodeMap());
        for (Service service : holdings.getServices()) {
            String status = service.getFirstStatusCode();
            if (status != null) {
                codeMap.add(status);
            }
        }
        codeMapBuilder.put(category, codeMap);
    }
}
