package org.xbib.interlibrary.catalog.elasticsearch.lvi.statistics;

import java.io.IOException;
import java.util.ConcurrentModificationException;
import java.util.Map;
import org.xbib.datastructures.tiny.TinyMap;

public interface Statistics<C, R> {

    void count(C countable);

    Map<String, R> map();

    void write(String fileName) throws IOException;

    class CodeMap  {

        private final TinyMap.Builder<String, Integer> builder;

        private Map<String, Integer> map;

        private boolean closed;

        public CodeMap() {
            this.builder = TinyMap.builder();
        }

        public void add(String code) {
            if (closed) {
                throw new ConcurrentModificationException();
            }
            Integer i = builder.getOrDefault(code, 0);
            builder.put(code, i + 1);
        }

        public Map<String, Integer> map() {
            if (map == null) {
                map = builder.build();
                closed = true;
            }
            return map;
        }

        public Map<String, Object> objectMap() {
            TinyMap.Builder<String, Object> map = TinyMap.builder();
            map.putAll(map());
            return map.build();
        }

        @Override
        public String toString() {
            return map().toString();
        }
    }
}
