package org.xbib.interlibrary.catalog.elasticsearch.openalex;

import java.time.Instant;
import java.util.Objects;
import java.util.regex.Pattern;

public class S3BucketInputDefinition {

    private final String bucket;

    private final Pattern pattern;

    private final Instant lastModified;

    public S3BucketInputDefinition(String bucket, Pattern pattern, Instant lastModified) {
        this.bucket = Objects.requireNonNull(bucket);
        this.pattern = Objects.requireNonNull(pattern);
        this.lastModified = Objects.requireNonNull(lastModified != null ? lastModified : Instant.EPOCH);
    }

    public Instant getLastModified() {
        return lastModified;
    }

    public String getBucket() {
        return bucket;
    }

    public Pattern getPattern() {
        return pattern;
    }

    @Override
    public String toString() {
        return "[bucket=" + bucket + ",pattern=" + pattern + ",lastmodified=" + lastModified + "]";
    }
}
