package org.xbib.interlibrary.catalog.elasticsearch.pubmed;

import java.io.FilterReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;

/**
 * This filter reader can process illegal XML 1.0 characters by skipping them.
 */
public class InvalidXmlCharacterFilterReader extends FilterReader {

    public InvalidXmlCharacterFilterReader(InputStream in, Charset encoding) throws UnsupportedEncodingException {
        super(new InputStreamReader(in, encoding));
    }

    @Override
    public int read(char[] ch, int off, int len) throws IOException {
        int n = super.read(ch, off, len);
        if (n == -1) {
            return -1;
        }
        for (int i = off; i < off + n; ++i) {
            ch[i] = filter(ch[i]);
        }
        return n;
    }

    private char filter(char ch) {
        return ch < 0x20 && ch != 0x09 && ch != 0x0a && ch != 0x0d ? 0x20 : ch;
    }
}
